﻿Imports GalaSoft.MvvmLight
Public Class ViewModelBase(Of T As {ViewModelBase(Of T), New}) : Inherits ViewModelBase

   Public Shared Instance As T = GetProvisionalInstance()
   Private Shared _IsProvisionalStatic As Boolean
   Public ReadOnly IsProvisional As Boolean

   Private Shared Function GetProvisionalInstance() As T
      _IsProvisionalStatic = True
      GetProvisionalInstance = New T
      _IsProvisionalStatic = False
   End Function

   Public Sub New()
      IsProvisional = _IsProvisionalStatic OrElse ViewModelBase.IsInDesignModeStatic
      If IsProvisional Then Return
      If Not Instance.IsProvisional Then Throw New Exception("Instance mustn't instanciated twice")
      Instance = DirectCast(Me, T)
   End Sub

End Class
